--Klein, mixnibbles step (decryption)

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

ENTITY klein_mixnibbles_d IS
  PORT (
    state_in  : IN STD_LOGIC_VECTOR(63 DOWNTO 0);
    state_out : OUT STD_LOGIC_VECTOR(63 DOWNTO 0)
    );
END klein_mixnibbles_d;

ARCHITECTURE rtl OF klein_mixnibbles_d IS

  SIGNAL tmp   : STD_LOGIC_VECTOR(63 DOWNTO 0);
  SIGNAL oct0  : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL oct1  : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL oct2  : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL oct3  : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL oct4  : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL oct5  : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL oct6  : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL oct7  : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL int1  : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL int2  : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL int3  : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL int4  : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL int5  : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL int6  : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL int7  : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL int8  : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL int9  : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL int10 : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL int11 : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL int12 : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL int13 : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL int14 : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL int15 : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL int16 : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL int17 : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL int18 : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL var1  : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL var2  : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL i1    : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL i2    : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL i3    : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL i4    : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL i5    : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL i6    : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL i7    : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL i8    : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL i9    : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL i10   : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL i11   : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL i12   : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL i13   : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL i14   : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL i15   : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL i16   : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL i17   : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL i18   : STD_LOGIC_VECTOR(7 DOWNTO 0);

  
  COMPONENT klein_xtimes IS
    PORT (
      x_in  : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
      x_out : OUT STD_LOGIC_VECTOR(7 DOWNTO 0)
      );
  END COMPONENT;

BEGIN

  oct0 <= state_in(3 DOWNTO 0) & state_in(7 DOWNTO 4);
  oct1 <= state_in(11 DOWNTO 8) & state_in(15 DOWNTO 12);
  oct2 <= state_in(19 DOWNTO 16) & state_in(23 DOWNTO 20);
  oct3 <= state_in(27 DOWNTO 24) & state_in(31 DOWNTO 28);
  oct4 <= state_in(35 DOWNTO 32) & state_in(39 DOWNTO 36);
  oct5 <= state_in(43 DOWNTO 40) & state_in(47 DOWNTO 44);
  oct6 <= state_in(51 DOWNTO 48) & state_in(55 DOWNTO 52);
  oct7 <= state_in(59 DOWNTO 56) & state_in(63 DOWNTO 60);

  var1 <= oct3 XOR oct1 XOR oct2 XOR oct0;
  var2 <= oct7 XOR oct6 XOR oct5 XOR oct4;

  i_klein_xtimes1 : klein_xtimes
    PORT MAP (
      x_in  => var1,
      x_out => int1
      );

  i1 <= int1 XOR oct2 XOR oct0;

  i_klein_xtimes2 : klein_xtimes
    PORT MAP (
      x_in  => i1,
      x_out => int2
      );

  i2 <= int2 XOR oct1 XOR oct0;

  i_klein_xtimes3 : klein_xtimes
    PORT MAP (
      x_in  => i2,
      x_out => int3
      );

  tmp(7 DOWNTO 0)  <= int3 XOR oct3 XOR oct1 XOR oct2;

  i3 <= int1 XOR oct3 XOR oct1;

  i_klein_xtimes4 : klein_xtimes
    PORT MAP (
      x_in  => i3,
      x_out => int4
      );

  i4 <= int4 XOR oct2 XOR oct1;

  i_klein_xtimes5 : klein_xtimes
    PORT MAP (
      x_in  => i4,
      x_out => int5
      );

  tmp(15 DOWNTO 8) <= int5 XOR oct0 XOR oct2 XOR oct3;

  i6 <= int2 XOR oct3 XOR oct2;

  i_klein_xtimes7 : klein_xtimes
    PORT MAP (
      x_in  => i6,
      x_out => int7
      );

  tmp(23 DOWNTO 16) <= int7 XOR oct1 XOR oct3 XOR oct0;

  i8 <= int4 XOR oct0 XOR oct3;

  i_klein_xtimes9 : klein_xtimes
    PORT MAP (
      x_in  => i8,
      x_out => int9
      );

  tmp(31 DOWNTO 24) <= int9 XOR oct2 XOR oct0 XOR oct1;

  i_klein_xtimes10 : klein_xtimes
    PORT MAP (
      x_in  => var2,
      x_out => int10
      );

  i10 <= int10 XOR oct6 XOR oct4;

  i_klein_xtimes11 : klein_xtimes
    PORT MAP (
      x_in  => i10,
      x_out => int11
      );

  i11 <= int11 XOR oct5 XOR oct4;

  i_klein_xtimes12 : klein_xtimes
    PORT MAP (
      x_in  => i11,
      x_out => int12
      );

  tmp(39 DOWNTO 32) <= int12 XOR oct7 XOR oct5 XOR oct6;

  i12 <= int10 XOR oct7 XOR oct5;
    
  i_klein_xtimes13 : klein_xtimes
    PORT MAP (
      x_in  => i12,
      x_out => int13
      );

  i13 <= int13 XOR oct6 XOR oct5;

  i_klein_xtimes14 : klein_xtimes
    PORT MAP (
      x_in  => i13,
      x_out => int14
      );

  tmp(47 DOWNTO 40) <= int14 XOR oct4 XOR oct6 XOR oct7;

  i15 <= int11 XOR oct7 XOR oct6;

  i_klein_xtimes16 : klein_xtimes
    PORT MAP (
      x_in  => i15,
      x_out => int16
      );

  tmp(55 DOWNTO 48) <= int16 XOR oct5 XOR oct7 XOR oct4;

  i17 <= int13 XOR oct4 XOR oct7;

  i_klein_xtimes18 : klein_xtimes
    PORT MAP (
      x_in  => i17,
      x_out => int18
      );

  tmp(63 DOWNTO 56) <= int18 XOR oct6 XOR oct4 XOR oct5;

  state_out(3 DOWNTO 0)   <= tmp(7 DOWNTO 4);
  state_out(7 DOWNTO 4)   <= tmp(3 DOWNTO 0);
  state_out(11 DOWNTO 8)  <= tmp(15 DOWNTO 12);
  state_out(15 DOWNTO 12) <= tmp(11 DOWNTO 8);
  state_out(19 DOWNTO 16) <= tmp(23 DOWNTO 20);
  state_out(23 DOWNTO 20) <= tmp(19 DOWNTO 16);
  state_out(27 DOWNTO 24) <= tmp(31 DOWNTO 28);
  state_out(31 DOWNTO 28) <= tmp(27 DOWNTO 24);
  state_out(35 DOWNTO 32) <= tmp(39 DOWNTO 36);
  state_out(39 DOWNTO 36) <= tmp(35 DOWNTO 32);
  state_out(43 DOWNTO 40) <= tmp(47 DOWNTO 44);
  state_out(47 DOWNTO 44) <= tmp(43 DOWNTO 40);
  state_out(51 DOWNTO 48) <= tmp(55 DOWNTO 52);
  state_out(55 DOWNTO 52) <= tmp(51 DOWNTO 48);
  state_out(59 DOWNTO 56) <= tmp(63 DOWNTO 60);
  state_out(63 DOWNTO 60) <= tmp(59 DOWNTO 56);



END rtl;

